<?php
$berogui_path = '/usr/local/www/berogui';
require("$berogui_path/includes/Helper/Helper.php");

require("/usr/fallback/beroConf.php");
$bc = new beroConf('root');

function doUpdate($reboot_required) {
	$output = null;
	try {
		$cmd =	'export PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/snap/bin:$PATH;'
					. "/bin/bash /usr/local/beroNet/bin/sbcvm-update $reboot_required >/dev/null";
		$retval = Helper::system(1, $cmd, $output, ['timeout' => 300]);
		return $retval != false;
	}
	catch (Exception $e) {
		return false;
	}
}

##### FORCE UPDATE AFTER AUTO FAILED OR TO FIX A MAJOR ISSUE ######
if (isset($_POST['force-update']) && $_POST['force-update']) {
	require("$berogui_path/misc/database.php");
	$ba = new beroAri();

	require_once("$berogui_path/includes/lang.php");
	if (Helper::getActivateOption() != '0') {
		header('Content-type: application/json');
		die(json_encode(['error' => SBCVM_UPDATE_FAILED_ACTIVATE_NOTIF]));
	}
	else if (Helper::getTotalCalls() != '0') {
		header('Content-type: application/json');
		die(json_encode(['error' => SBCVM_UPDATE_FAILED_ACTCALLS_NOTIF]));
	}

	if (!doUpdate(0)) {
		die(header("HTTP/1.0 500 Internal Server Error"));
	}
	foreach (['sbcvmupdate-notif', 'has-major-issue', 'sbcvm-has-update'] as $key) {
		$bc->delete('root', $key);
	}
	header('Content-type: application/json');
	die(json_encode(['success' => UPDATE_TOOL_SUCCESSFUL]));
}

##### MANUAL UPDATE #####
/* [CHECKING GET] */
unset($_GET);

/* [CHECKING POST] */
unset($_POST);

/* [EXEC AJAX] */
require_once('/usr/fallback/beroConf.php');
$bc = new beroConf('root');

$reboot_required = $bc->get('root', 'sbcvmupdate-reboot') == 1 ? 1 : 0;
if (!doUpdate($reboot_required)) {
	die(header("HTTP/1.0 500 Internal Server Error"));
}

// clean database
foreach (['has-major-issue', 'sbcvm-has-update'] as $key) {
	$bc->delete('root', $key);
}

echo $bc->get('root', 'sbcvm-current-package');
exit(1);
?>
